#include "StringUtils.hh"

std::strstream& StringUtils::operator >> ( std::strstream& in, bool& w )
{
  std::string s;

  in >> s;

  strip( s );

  if( isnum( s ) )
    {
      int b = s2x<int>( s );
      if( b > 0 )
	w = true;
      else
	w = false;
      return in;
    }

  toupper( s );
      
  if( std::strcmp( s.c_str(), "TRUE") == 0 ) 
    w = true; 
  else
    w = false;
     
  return in;
}

bool StringUtils::isnum( const std::string &s )
{
  for( unsigned int i=0; i<s.size(); i++ )
    {
      //      cout << "sign: \"" << s[i] << "\" " << static_cast<int>(s[i]) << endl;
      if( !isdigit( s[i] ) &&
	  s[i] != '.' &&
	  s[i] != 'E' &&
	  s[i] != 'e' &&
	  s[i] != '-' &&
	  s[i] != '+' &&
	  s[i] != '\0')
	return false;
    }
  
  return true;
}

void StringUtils::strip( std::string& str )
{
  if( str.empty() ) 
    return;

  std::string::size_type start = str.find_first_not_of( " \t" );
  std::string::size_type end = str.find_last_not_of( " \t" );

  if( start == std::string::npos )
    start = 0;

  if( !end == std::string::npos )
    if( end - start + 1 <= 0 )
      str = std::string();

  str = str.substr( start, end - start + 1 );
}
