#ifndef StringUtils_hh
#define StringUtils_hh

#include <strstream>
#include <string>
#include <cctype>

namespace StringUtils ///< a collection of useful string functions
{
  void strip( std::string& str ); ///< strips a string
  template <class T> std::string x2s( T t ); ///< converts anything to a string
  template <class T> T s2x( const std::string& s ); ///< extract anything from a string
  std::strstream& operator >> ( std::strstream& in, bool& w ); ///< reads a boolean value from a strstream
  bool isnum( const std::string& s ); ///< returns true if the string is a number
  void toupper( std::string &s ); ///< converts a string to upper case 
  
  template<class T>std::string x2s( T what )
    {
      std::strstream str;
      
      str << what << std::ends;
      std::string s( str.str() );
      str.freeze(0);
      return s;
    }
  
  template <class T> T s2x( const std::string& s )
    {
      std::strstream str;
      
      str << s << std::ends;
      T t;
      str >> t;
      str.freeze(0);
      return t;
    }
  
  inline void toupper( std::string &s )
    {
      for( unsigned int i=0; i< s.size(); i++ )
	s[i] = std::toupper( s[i] );
    }
}

#endif
